/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   lm_utils_parser.c                                  :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: mndhlovu <marvin@42.fr>                    +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/04/04 09:24:45 by mndhlovu          #+#    #+#             */
/*   Updated: 2019/04/24 09:47:29 by tmaze            ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "lem_in.h"

int             lm_get_value(char *line)
{
    int         index;

    if (line != NULL)
    {
        index = ft_atoi(line);
        if (index > INT_MIN && index < INT_MAX)
        {
            if (index > 0)
                return (index);
            else
            {
                return (-1);
            }
        }
    }
    return (-1);
}

void             lm_get_cmd_vert(int count, t_syntax *synt
								, t_lmdata *ldata, char *line)
{
    char        *tmp;

    if (synt->s_pos == count - 1)
    {
        tmp = ft_strchr(line, '#');
        if (tmp == NULL && count != synt->e_vert)
        {
            synt->s_vert = count;
            if (!(lm_add_vertex(ldata, line, 's', synt)))
                synt->e_error = 1;
        }
    }
    if (synt->e_pos == count - 1)
    {
        tmp = ft_strchr(line, '#');
        if (tmp == NULL && count != synt->s_vert)
        {
            synt->e_vert = count;
            if (!(lm_add_vertex(ldata, line, 'e', synt)))
                synt->s_error = 1;
        }
    }
}

void             lm_get_vert_link(int count, t_syntax *synt, t_lmdata *ldata
								, t_holder *holder, char *line)
{
     if (count > 0 && (count != synt->s_vert && count != synt->e_vert)
        && (count != synt->s_pos && count != synt->e_pos))
     {
         if (lm_check_forbiden_chars(line, 0))
         {
             ft_printf("Bingo 7 %s\n", line);
             if (!(lm_add_vertex(ldata, line, 'v', synt)))
             {
                 synt->v_error = 1;
             }
         }
         if (lm_check_forbiden_chars(line, 3))
         {
             if (!(lm_ext_conn(holder, ldata, line)))
             {
                 synt->l_error = 1;
                 return ;
             }
         }
     } 
}
